=== debian/changelog ===
ros-kinetic-rtabmap-ros (0.20.7-1xenial) xenial; urgency=high

  * Autogenerated, no changelog for this version found in CHANGELOG.rst.

 -- Mathieu Labbe <matlabbe@gmail.com>  Sun, 13 Dec 2020 01:02:02 -0000
