=== debian/control ===
Source: ros-kinetic-rtabmap-ros
Section: misc
Priority: optional
Maintainer: Mathieu Labbe <matlabbe@gmail.com>
Build-Depends: debhelper (>= 9.0.0), libpcl-dev, ros-kinetic-catkin, ros-kinetic-class-loader, ros-kinetic-costmap-2d, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-eigen-conversions, ros-kinetic-find-object-2d, ros-kinetic-genmsg, ros-kinetic-geometry-msgs, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-laser-geometry, ros-kinetic-message-filters, ros-kinetic-message-generation, ros-kinetic-move-base-msgs, ros-kinetic-nav-msgs, ros-kinetic-nodelet, ros-kinetic-octomap-msgs, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-pluginlib, ros-kinetic-roscpp, ros-kinetic-rosgraph-msgs, ros-kinetic-rospy, ros-kinetic-rtabmap, ros-kinetic-rviz, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-stereo-msgs, ros-kinetic-tf, ros-kinetic-tf-conversions, ros-kinetic-tf2-ros, ros-kinetic-visualization-msgs
Homepage: 
Standards-Version: 3.9.2

Package: ros-kinetic-rtabmap-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-kinetic-class-loader, ros-kinetic-compressed-depth-image-transport, ros-kinetic-compressed-image-transport, ros-kinetic-costmap-2d, ros-kinetic-cv-bridge, ros-kinetic-dynamic-reconfigure, ros-kinetic-eigen-conversions, ros-kinetic-find-object-2d, ros-kinetic-geometry-msgs, ros-kinetic-image-geometry, ros-kinetic-image-transport, ros-kinetic-laser-geometry, ros-kinetic-message-filters, ros-kinetic-message-runtime, ros-kinetic-move-base-msgs, ros-kinetic-nav-msgs, ros-kinetic-nodelet, ros-kinetic-octomap-msgs, ros-kinetic-pcl-conversions, ros-kinetic-pcl-ros, ros-kinetic-pluginlib, ros-kinetic-roscpp, ros-kinetic-rosgraph-msgs, ros-kinetic-rospy, ros-kinetic-rtabmap, ros-kinetic-rviz, ros-kinetic-sensor-msgs, ros-kinetic-std-msgs, ros-kinetic-std-srvs, ros-kinetic-stereo-msgs, ros-kinetic-tf, ros-kinetic-tf-conversions, ros-kinetic-tf2-ros, ros-kinetic-visualization-msgs
Description: RTAB-Map's ros-pkg.
 RTAB-Map is a RGB-D SLAM approach with real-time constraints.
